; This code moves the man/men ( S.Brattel )

MM_Man:		push cx			; Save cnt

		; Copy speeds

		mov al,mSpeed[si]	; Reset cnt
		mov mDelay[si],al	;

		; Assert its look flag

		mov al,mType[si]	; 0 or 1

		add al,1		; 1 or 2 (01) or (10)

		or cs:Man_Look,al	; Assert the flag

		; Remove it from the maze

		mov di,mSeg[si]		; Point at man
		mov es,di		;
		mov di,mOff[si]		;

		mov al,mUnderChar[si]	; Get the background char

		mov es:[di],al		; Clear the man from the maze
		mov es:BM_Width[di],al	; Clear legs

		; Now try to move the man

		mov al,mDirection[si]	; Dirn
		mov cx,es		; Seg

		call Try_Man_Move	; Try to move him

		; Did we move last time ?

		test b mFlags[si],01h	; Moved ?
		jnz MM_Check_Moved	; Yes, don't check dirn

		; No, so check if dirn has changed

		cmp al,mDirection[si]	; Same dirn ?
		jne MM_Same_Place	; No, so rotate - don't move

MM_Check_Moved: and b mFlags[si],0FEh	; Clear the moved flag

		; Check if we have moved

		cmp cx,mSeg[si]		; Same seg ?
		jne MM_Moved		; No, moved
		cmp di,mOff[si]		; Same offset ?
		je MM_Same_Place	; Yes, not moved

		; We have moved, flag this fact

MM_Moved:	or b mFlags[si],01h	; Assert moved

		push es			; Save
		push di			;
		push cx			;
		push ax			;

		; Remove from the screen

		mov di,mSeg[si]		; Point at man
		mov es,di		;
		mov di,mOff[si]		;

		mov al,mUnderChar[si]	; Get the background char

		call ShowAddr		;

		mov cx,es		; Move down
		add cx,BM_Y_Stride	;
		mov es,cx		;

		call ShowAddr		;

		mov cx,es		; Move back
		sub cx,BM_Y_Stride	;
		mov es,cx		;

		pop ax			; Restore
		pop cx			;
		pop di			;
		pop es			;

		; Now store the NEW position

		mov mSeg[si],cx		; Save the new posn
		mov mOff[si],di		;

		; Now store the dirn

MM_Same_Place:	mov mDirection[si],al	; Store new direction

		mov di,mSeg[si]		; Point at the man
		mov es,di		;
		mov di,mOff[si]		; 

		; Store the character under the man

		mov ah,es:[di]		; Get it
		mov mUnderChar[si],ah	; Store it

		; Now redraw the man

		and al,0006h		; Orthogonal only

		add al,cMan		; Add base

		mov es:[di],al		; The top half
		call ShowAddr		;

		inc al			; Step to next char

		mov dx,es		; Step down
		add dx,BM_Y_Stride	;
		mov es,dx		;		

		mov es:[di],al		; The bottom
		call ShowAddr		;

		mov dx,es		; Step back
		sub dx,BM_Y_Stride	;
		mov es,dx		;		

		; Have we moved off the display ?

		mov ax,mSeg[si]		; Calc the man's Y
		sub ax,cs:BM_Base	; Y offset

		mov dx,0		; 32 - bit

		mov cx,BM_Y_Stride	; Line length

		idiv cx			; Calc Y offset

		sub ax,cs:ScreenY	; Get its position

		cmp ax,1		; Top "Edge"
		jb MM_P_Up		;

		cmp ax,23-1		; Off bottom ?
		jb MM_P_X		; No, try X

		add w cs:ScreenY,3*7	; Move down

		; Assert changed

		mov b cs:ShowChanged,1	; Flag changed

		jmp s MM_P_X		; Try X

MM_P_Up:	sub w cs:ScreenY,3*7	; Move Up

		; Assert changed

		mov b cs:ShowChanged,1	; Flag changed

		; Now test the X

MM_P_X:		mov ax,mOff[si]		; Calc the man's X
		sub ax,cs:ScreenX	; X offset

		cmp ax,2		; "Edge"
		jb MM_P_Left		; Move screen left

		cmp ax,40-2		; Off Right ?
		jb MM_P_Done		; No, ok

		add w cs:ScreenX,5*7	; Move right

		; Assert changed

		mov b cs:ShowChanged,1	; Flag changed

		jmp s MM_P_Done		; Done

MM_P_Left:	sub w cs:ScreenX,5*7	; Move left

		; Assert changed

		mov b cs:ShowChanged,1	; Flag changed

		; Now justify ?

MM_P_Done:	test b cs:Man_Keys_2,01h; Space ?
		jz MM_NotJust		; No, skip

		call Justify_Screen	; Centre the man

		; Try keep/drop

MM_NotJust:	test b cs:Man_Keys_1,40h; Keep ?
		jz MM_Drop		; No, skip

		; Try to keep something

		call Calc_Local		; Return di/bx as the local cells

		; Try the first local cell

		call MM_KeepCell	; Drive the keep option

		or al,al		; Did we keep anything ?
		jnz MM_Drop		; Yes, skip

		; Two local cells ?

		cmp bx,0		; Two ?
		jz MM_Drop		; No, skip

		; Try again with the bottom cell

		push es			; Save

		mov ax,es		; Move down
		add ax,bx		;
		mov es,ax		;

		call MM_KeepCell	; Try again

		pop es			; Restore

		; Keep finished

MM_Drop:	test b cs:Man_Keys_1,80h; Drop ?
		jz MM_Proj		; No, skip

		; Anything to drop ?

		test b mnSwag[si],0FFh	; Any swag ?
		jz MM_Proj		; No, skip

		; Look locally

		call Calc_Local		; Return di/bx as the local cells

		; Try the first local cell

		call MM_DropCell	; Drive the drop option

		or al,al		; Did we drop anything ?
		jnz MM_Proj		; Yes, skip

		; Two local cells ?

		cmp bx,0		; Two ?
		jz MM_Proj		; No, skip

		; Try again with the bottom cell

		push es			;

		mov ax,es		; Try the other ptr
		add ax,bx		;
		mov es,ax		;

		call MM_DropCell	; Try again

		pop es			;

		; Drop finished, try projectiles

MM_Proj:	test b cs:Man_Keys_1,30h; Light or Fire ?
		jz MM_Exit		; No, skip

		; One of the projectiles is wanted, find the best target

		mov bx,o Sight_WS_0	; Assume man 0
		mov bp,mProjCnt		; Point at man 0 count

		mov al,mType[si]	; Man 0 ?
		cmp al,0		;
		jz MMP_1		; Skip

		mov bx,o Sight_WS_1	; Man 1
		mov bp,mProjCnt+2	; Point at man 1 count

		; Setup some initial values

MMP_1:		mov dx,32000		; Silly high proj cnt
		mov ah,127		; High range

		; Now find the nearest thing that has the lowest mProj_Cnt

MMP_Lp:		mov al,cs:sRange[bx]	; Giz range
		cmp al,127		; Valid ?
		jz MMP_X		; No, skip

		; Giz a ptr to the thing

		mov di,bp		; Get ptr to target		
		add di,cs:spTarget[bx]	; Point at the target's ProjCnt

		; Is this a lower Proj cnt ?

		cmp dx,[di]		; Lower cnt ?

		je MMP_SP		; Same cnt

		jc MMP_N		; No, get next

		; This has a lower proj cnt

		mov cx,bx		; Save ptr to it

		mov dx,[di]		; Save the new lower cnt
		mov ah,cs:sRange[bx]	; Get the new range

		; Try the next thing

MMP_N:		add bx,lSight		; Skip to the next

		jmp s MMP_Lp		; Loop

		; This has the same number of projectiles aimed at it, is it
		; closer ?

MMP_SP:		cmp al,ah		; Compare the ranges
		jae MMP_N		; Further or same, ignore

		; Point at this one instead

		mov cx,bx		; Save ptr to it
		mov ah,al		; Save new range

		jmp s MMP_Lp		; Loop

		; Now see if we found one

MMP_X:		cmp ah,127		; Any found ?
		je MM_Exit		; No, skip

		; Giz a pointer to the best one

		mov bx,cx		; bx := ptr

		; Now check light/fire

MM_Light:	test b cs:Man_Keys_1,10h; Light ?
		jz MM_Exit		; No, skip

		; Fire a lightning bolt

		push es			; Save es

		; Giz es:bx as a ptr to line defn

		mov ax,cs		; es := cs
		mov es,ax		;

		call Add_Lightning	; Fire one

		; Lightning done

MM_LightOver:	pop es			; Restore

MM_Exit:	pop cx			; Done
		ret			;

; Centre the man on the display given si

Justify_Screen:	mov ax,mSeg[si]		; Calc Y from segment
		sub ax,cs:BM_Base	; Offset

		mov dx,0		; 32-bit

		mov cx,BM_Y_Stride	; Offset in paras

		idiv cx			; dx:ax := Y in cells

		sub ax,1		; Up one
		sbb dx,0		;

		mov cx,7		; 7 Cells per room

		idiv cx			; dx:ax := rooms

		imul cx			; dx:ax := cell room start

		sub ax,7		; Offset of one room

		mov cs:ScreenY,ax	; Store it

		; Now X

		mov ax,mOff[si]		; Calc Y from segment
		mov dx,0		; 32-bit

		sub ax,1		; dx:ax in cells
		sbb dx,0		;

		mov cx,7		; 7 Cells per room

		idiv cx			; dx:ax := rooms

		imul cx			; dx:ax := cell room start

		sub ax,7*2+1		; Offset of two rooms + one cell

		mov cs:ScreenX,ax	; Store it

		; Assert changed

		mov b cs:ShowChanged,1	; Flag changed

		ret			; Done

; Return di as the offsets to the local cell and bx = 0 for up/down
; or bx = segment offset for the bottom cell if there are two local cells

Calc_Local:	mov bl,mDirection[si]	; Giz the dirn.

		and bx,0006h		; Clip 0,2,4,6

		mov di,bx		; * 1
		add bx,bx		; * 2
		add bx,di		; * 3

		add bx,o CL_ThingTab	; Point at the table

		test b mFlags[si],04h	; Man or thing ?
		jz CL_1			; Thing

		add bx,o CL_ManTab - o CL_ThingTab ; Point at the man's table

		; Get the man's posn

CL_1:		mov di,mSeg[si]		; Segment
		add di,cs:[bx]		; Segment offset
		mov es,di		;

		mov di,mOff[si]		; Offset

		add di,cs:2[bx]		; Add first offset

		mov bx,cs:4[bx]		; Segment offset
		ret			; Done

; Return dirn, seg and off in ax,cx and di according to keys

Try_Man_Move:	mov cs:TMM_Off,di	; Save the ptr
		mov cs:TMM_Seg,cx	;
		mov cs:TMM_Dir,al	;

		mov ah,cs:Man_Keys_1	; Get move flags
		and ah,0Ch		; Down/Up

		cmp ah,04h		; Up
		jz TMM_Up		; Yes

		cmp ah,08h		; Down ?
		jnz TMM_LR		; No

		; Move down

		add cx,BM_Y_Stride	; Step down

		mov al,4		; Point down

		jmp TMM_LR		; Try it		

		; Move up

TMM_Up:		sub cx,BM_Y_Stride	; Step Up

		mov al,0		; Point up

		; Try this up/down move

TMM_LR:		mov es,cx		; Point at it

		cmp b es:[di],090h	; Shield ?
		je TMM_LRa		; Yes, pass

		test b es:[di],0DFh	; Get this cell, is it 00 or 20 ?
		jne TMM_LR_1		; No, can't move

TMM_LRa:	cmp b es:BM_Width[di],090h; Shield ?
		je TMM_LRb		; Yes, pass

		test b es:BM_Width[di],0DFh ; 00 or 20 ?
		jnz TMM_LR_1		; No, can't move

		; We can move to here . . 

TMM_LRb:	mov cs:TMM_Seg,cx	; Save this posn
		mov cs:TMM_Dir,al	; and dirn

		; Now try left or right

TMM_LR_1:	mov cx,cs:TMM_Seg	; Restore last valid posn
		mov es,cx		;
;		mov al,cs:TMM_Dir	;

		; Look at keys

		mov ah,cs:Man_Keys_1	; Get move flags
		and ah,03h		; Left/Right

		cmp ah,01h		; Left
		jz TMM_Left		; Yes

		cmp ah,02h		; Right ?
		jnz TMM_Test		; No

		; Move right

		add di,1		; Step right

		mov al,2		; Point right

		jmp TMM_Test		; Try it

TMM_Left:	sub di,1		; Step left

		mov al,6		; Point left

		; Try this position

TMM_Test:	cmp b es:[di],090h	; Shield ?
		je TMM_Ta		; Yes, pass

		test b es:[di],0DFh	; Get this cell, is it 00 or 20 ?
		jnz TMM_Fail		; No, can't move

TMM_Ta:		cmp b es:BM_Width[di],090h; Shield ?
		je TMM_Tb		; Yes, pass

		test b es:BM_Width[di],0DFh ; 00 or 20 ?
		jnz TMM_Fail		; No, can't move

		; We can move to here . . 

TMM_Tb:		ret			; Ignore

; Return the last valid position

TMM_Fail:	mov di,cs:TMM_Off	; Offset (Segm. must be right)

		ret			; Done

