; Drive the projectiles,ie lightning, fire, arrows etc ( S.Brattel )

; Fire a lightning bolt, given ds:si = Owner and es:bx = pLineData

AL_X1:		mov b mWeap_Cost[si],-1	; Ensure we cannot use them next time

		; Exit

AL_X:		ret			; Fucking stupid short branches

		; Entry

Add_Lightning:	add b mWeap_Cost[si],Light_Cost	; Add cost of firing
		jnc AL_1			; Ok, skip

		; Can we afford it ?

		mov al,mMagic[si]	; Have we got enough magic ?
		or al,al		; Any ?

		jz AL_X1		; No, skip

		dec b mMagic[si]	; Reduce it

		; Try to fire it

AL_1:		call New_Proj		; Giz some space cs:di
		jc AL_X			; Failed

		; We have room, setup vars

		mov cs:ppOwner[di],si	; Ptr to owner

		; Type (0,1 = man and 2 = thing)

		mov al,mType[si]	; Get type
		mov cs:pFirepCnt[di],al	; Store it

		; Init speed vars

		mov b cs:pDelay[di],1	; Start right away
		mov b cs:pSpeed[di],1	;
		mov b cs:pSpeedDel[di],1;

		mov cs:ppSpeedTab[di],o Light_Tab ; Use these speeds

		; No char underneath yet

		mov b cs:pUnderChar[di],1 ; Not drawn yet

		; Start arming delay

		mov b cs:pStartCnt[di],3; Delay before it can hurt its owner

		; Start at the owners position

		mov ax,mSeg[si]		; Seg
		mov cs:pSeg[di],ax	;
		mov ax,mOff[si]		; Off
		mov cs:pOff[di],ax	;

		; Get the line-drawing parameters

		mov ax,es:sdHoriz[bx]	; Get horiz vector
		mov cs:pdHoriz[di],ax	;
		mov ax,es:sdHoriz+2[bx]	;
		mov cs:pdHoriz+2[di],ax	;

		mov ax,es:sdDiag[bx]	; Get diag vector
		mov cs:pdDiag[di],ax	;
		mov ax,es:sdDiag+2[bx]	;
		mov cs:pdDiag+2[di],ax	;

		mov al,es:s_e[bx]	; E
		mov cs:p_e[di],al	;
		mov al,es:s_c1[bx]	; C1
		mov cs:p_c1[di],al	;
		mov al,es:s_c2[bx]	; C2
		mov cs:p_c2[di],al	;

		push si			; Save ptr

		mov al,cs:pFirepCnt[di]	; 0,1 or 2
		mov ah,0		; 16-bit

		add ax,ax		; * 2

		mov si,es:spTarget[bx]	; Ptr to target monster
		mov cs:ppTarget[di],si	;

		add si,ax		; Add displacement to the correct cnt

		; Step the ProjCnt

		inc w mProjCnt[si]	; Step the count

		pop si			; Restore

		; Choose the projectile move routine

		mov cs:ppMove[di],o Move_Light_E ; The light move routine

		; Done, link it to the front of the projectile list

		mov ax,cs:pProjList	; Point at the first entry
		mov cs:ppNext[di],ax	; Point at it

		mov cs:pProjList,di	; Point at new, linked

		; Done

		ret			;

; Setup the free projectiles list

init_proj:	mov si,o Proj_List	; Point at the projectiles

		; Clear the projectile list

		mov cs:pFreeProj,si	; Set ptr to first

		mov cx,nProjs-1		; Number
		mov bx,lProj		; Size

IP_Lp:		mov ax,si		; Calc ptr to next
		add ax,bx		;

		mov cs:ppNext[si],ax	; Link next

		mov si,ax		; Point at next

		loop IP_Lp		; Loop

		mov w cs:ppNext[si],0	; Terminate

		; No projectiles yet

		mov w cs:pProjList,0	; None in the list yet

MP_X:		ret			; Done

; Move the projectiles

Move_Proj:	mov si,o pProjList	; Point at the pointer to the first

		; Cope with the next projectile

MP_Lp:		mov bp,si		; Save the ptr to the ptr

		mov si,cs:ppNext[si]	; Point at the next projectile

		cmp si,0		; End ?
		jz MP_X			; Yes, done

		; This projectile is valid, move it yet ?

		dec b cs:pDelay[si]	; Dec count
		jnz MP_Lp		; Not move yet, try next

		; Is it active yet ?

		test b cs:pStartCnt[si],0FFh ; Active yet ?
		jz MP_1			     ; Yes

		dec b cs:pStartCnt[si]	; Dec inactive cnt

MP_1:		dec b cs:pSpeedDel[si]	; Time to change speed ?
		jnz MP_DoIt		; No, skip

		; We should now get the new speed value

		mov bx,cs:ppSpeedTab[si]; Get pointer to table

		mov ax,cs:[bx]		; Get speeddel and speed

		cmp ax,0		; End of list ?
		jz MP_Kill_Und		; Yes, kill it and undraw

		inc bx			; Step ptr
		inc bx			;		

		mov cs:ppSpeedTab[si],bx; Save ptr

		mov cs:pSpeedDel[si],al	; Store speeds
		mov cs:pSpeed[si],ah	;

		; Now move the missile

MP_DoIt:	mov al,cs:pSpeed[si]	; Setup the speed
		mov cs:pDelay[si],al	;

		; Undraw the projectile

		mov di,cs:pSeg[si]	; Giz seg
		mov es,di		;
		mov di,cs:pOff[si]	; Giz off

		mov al,cs:pUnderChar[si]; Get the character under the proj

		test al,0DFh		; Was it 00 or 20 (blank ?)
		jnz MP_Undrawn		; No, skip

		; remove proj

		mov es:[di],al		; Undraw it
		call ShowAddr		;

		; Check for door, and kill if so

MP_Undrawn:	mov al,es:[di]		; Get the char here

		and al,0FEh		; Is it a door ?
		cmp al,cDoors		;

		jz MP_Kill		; Yes, kill this proj

		; Now move it

		jmp cs:ppMove[si]	; Jump to the move routine

; Now replace the thing in the maze

MP_Done:	mov al,es:[di]		; Get the char under us

		mov cs:pUnderChar[si],al; Save it

		test al,0DFh		; Blank ?
		jnz MP_Lp		; No, loop

		; Draw the projectile

		mov al,cs:pChar[si]	; Giz the proj char
		mov es:[di],al		; Write it
		call ShowAddr		;

		jmp s MP_Lp		; Loop		

; Undraw then kill the projectile

MP_Kill_Und:	mov di,cs:pSeg[si]	; Giz seg
		mov es,di		;
		mov di,cs:pOff[si]	; Giz off

		mov al,cs:pUnderChar[si]; Get the character under the proj

		test al,0DFh		; Was it 00 or 20 (blank ?)
		jnz MP_Kill		; No, skip

		; remove proj

		mov es:[di],al		; Undraw it
		call ShowAddr		;

		; Kill the projectile

		; First dec the proj cnt of the target

MP_Kill:	push si			; Save ptr
		push ds			; Save seg

		mov al,cs:pFirepCnt[si]	; 0,1 or 2
		mov ah,0		; 16-bit

		add ax,ax		; * 2

		add ax,cs:ppTarget[si]	; Add base

		mov si,ax		; Point at target

		; Step the ProjCnt

		mov ax,cs:Monster_Base	; Setup seg
		mov ds,ax		;

		dec w mProjCnt[si]	; Step the count

		pop ds			; Restore
		pop si			;

		; Return it to free space

		mov ax,cs:ppNext[si]	; Get the next proj
		mov cs:ppNext[bp],ax	; Unlink the present one

		call Kill_Proj		; Free the present one

		mov si,bp		; Rewind ptr

		jmp MP_Lp		; Loop

; Now we have the various movement routines

Move_Light_E:	mov dl,4		; Bounce this many times

Move_Light:	dec dl			; Prevent infinite bouncing
		jz MP_Kill		; Kill us

		; Calc next posn

		mov al,cs:p_e[si]	; Calc next posn

		cmp al,0		; E > 0 ?
		jns ML_Line_1		; Yes

		add al,cs:p_c2[si]	; e := e + 2dy

		; Perform horiz move

		add di,cs:pdHoriz[si]	; Add X
		mov bx,es		; Get "Y"
		add bx,cs:pdHoriz+2[si]	; Add
		mov es,bx		;

		; OK

		jmp s ML_Line_Done	; Moved, store new e

ML_Line_1:	add al,cs:p_c1[si]	; e := e + 2dy - 2dx

		; Perform diag move

		add di,cs:pdDiag[si]	; Add X
		mov bx,es		; Get "Y"
		add bx,cs:pdDiag+2[si]	; Add
		mov es,bx		;

		; Moved, store new error term

ML_Line_Done:	mov cs:p_e[si],al	; Save error term

		; Check what (if anything) we have hit

		mov al,es:[di]		; Giz cell

		test al,0DFh		; Blank ?
		jz ML_A			; Yes, nearly done

		; Is it a door ?

		and al,0FEh		; Clip type
		cmp al,cDoors		; Is it a door ?
		jz ML_Bounce		; Yes, bounce

		; Is it a sword ?

		and al,0FCh		; Clip type
		cmp al,cSwords		; Is it a sword ?
		jz ML_Sword		; Yes, test armed

		; Is it a thing ?

		and al,0F8h		; Clip type
		cmp al,cMonsters	; Is it a thing ?
		jz ML_Hit		; Yes, hit it

		; Is it a man ?

		cmp al,cMan		; Is it a man ?
		jz ML_Hit		; Yes, hit it

		; Is it a wall ?

		and al,0F0h		; Clip type
		cmp al,cWalls		; Is it a wall ?
		jz ML_Bounce		; Yes, bounce

		; Write over it ( is this a good idea ?	)

ML_A:		mov cs:pOff[si],di	; Sav ptr
		mov ax,es		;
		mov cs:pSeg[si],ax	;

		; Cycle character

		mov al,cs:pChar[si]	; Giz the current shape

		add al,01h		; Inc
		and al,01h		; Mask

		or al,cLight		; Add base

		mov cs:pChar[si],al	; Store

		jmp MP_Done		; Done

; Hit a sword, is it armed ?

ML_Sword:	test b cs:pStartCnt[si],0FFh ; Armed yet ?
		jnz ML_A		     ; No, ignore

		jmp MP_Kill		; Yes, kill proj

; We have hit something, do damage

ML_Hit:		mov bx,cs:ppOwner[si]	; Point at the owner of the lightning

		mov al,Light_Dam	; Damage cnt
		mov ah,2		; Fire/Light

		mov bx,cs:ppOwner[si]	; Owner of light

		push dx			; Save

		; Is the projectile active yet ?

		test b cs:pStartCnt[si],0FFh ; Active ?
		jnz MLH_O		     ; No, don't hit the owner

		call Hit_Thing		; Cause damage

		pop dx			; Restore

		jmp MP_Kill		; Done

		jmp s ML_A		; Continue

		; Same for owner if not armed

MLH_O:		call Hit_Thing_Not_O	; Cause damage, but not to the owner

		pop dx			; Restore

		jmp s ML_A		; Continue

; Bounce the lightning

ML_Bounce:	call Bounce		; Bounce off the wall

		jmp Move_Light		; Try again

; Generic bounce routine, given cs:si = proj

Bounce:		push ds			; Save ds, we need ds:bx as a ptr

		; Giz ptr

		mov di,cs:pSeg[si]	; Seg
		mov es,di		;
		mov di,cs:pOff[si]	; Off

		; Get ds:bx as a pointer in the horiz dirn.

		mov bx,cs:pdHoriz[si]	; X offset
		add bx,di		; 

		mov ax,es		; Seg
		add ax,cs:pdHoriz+2[si]	; Y offset
		mov ds,ax		;

		; Is this a wall / door ?

		mov al,[bx]		; Get char
		call TestWall		; Wall ?
		jne B_1			; No, skip

		; Negate the Horiz offset

		neg w cs:pdHoriz[si]	; Negate X
		neg w cs:pdHoriz+2[si]	;	 Y

		; Horiz steps only ?

B_1:		test b cs:p_c2[si],0FFh	; 0 ?
		jz B_X			; Yes, done

		; Get ds:bx as a pointer in the vertical bit of the diag dirn.

		mov ax,es		; Seg
		add ax,cs:pdDiag+2[si]	; Y offset
		mov ds,ax		;

		; Clear negated flag

		mov ah,0		; Not reflected yet

		; Is this a wall / door ?

		mov al,[di]		; Get char

		call TestWall		; Wall ?
		jne B_1b		; No, skip

		; Assert reflected

		mov ah,1		; We have negated dY

		; Now we try the horizontal bit of the diag vector

B_1b:		mov bx,cs:pdDiag[si]	; X offset
		add bx,di		; 

		; Is this a wall / door ?

		mov al,es:[bx]		; Get char

		call TestWall		; Wall ?
		jne B_1c		; No, skip

		; Assert reflected

		or ah,2			; We have negated dX

		; Have we reflected any of it ?

B_1c:		cmp ah,0		; Reflected either ?
		jz B_2			; No, reflect both

		test ah,01h		; reflect dY ?
		jz B_1d			; No, skip

		neg w cs:pdDiag+2[si]	; dY

B_1d:		test ah,02h		; reflect dX ?
		jz B_1e			; No, skip

		neg w cs:pdDiag[si]	; dX

B_1e:		pop ds			; Done
		ret			;

		; Reflect both dx,dy in diag and horiz

B_2:		neg w cs:pdHoriz[si]	; dX
		neg w cs:pdHoriz+2[si]	; dY

		neg w cs:pdDiag[si]	; dX
		neg w cs:pdDiag+2[si]	; dY

B_X:		pop ds			; Restore
		ret			; Done

; Are we looking at a wall ?

TestWall:	and al,0FEh		; Door ?
		cmp al,cDoors		;
		je TW_X			; Yes, skip

		and al,0FCh		; Sword ?
		cmp al,cSwords		;
		je TW_X			; Yes, skip

		cmp al,cLight		; Light ?
		je TW_X			; Yes, done

		and al,0F0h		; Wall ?
		cmp al,cWalls		;

TW_X:		ret			; Done

; Given al = damage, ah = reason, bx = pOwner, es:di = thing

; ah =	0 sword
;	1 arrow
;	2 fire/lightning

; Hit_Thing_Not_O will not inflict damage if the thing hit is bx

Hit_Thing_Not_O:push ds			; Save
		push si			;
		push cx			;

		; Find the target

		push bx			; Save owner
		push ax			;      damage

		call Find_Thing		; Return ds:si

		pop ax			;
		pop bx			;

		jnz HT_X		; Failed, skip

		; If the thing hit is the owner, then ignore 

		cmp bx,si		; Is the owner the target ?
		jne HT_Found		; No, carry on

		pop cx			; Restore
		pop si			;
		pop ds			;

		ret			;

; Hit it regardless

Hit_Thing:	push ds			; Save
		push si			;
		push cx			;

		; Find the target

		push bx			; Save owner
		push ax			;      damage

		call Find_Thing		; Return ds:si

		pop ax			;
		pop bx			;

		jnz HT_X		; Failed, skip

		; Found, now inflict damage

HT_Found:	add mWounds[si],al	; Accumulate damage
		jnc HT_X		; Still alive

		; Dead, clip damage back to 255 and kill it

		mov b mWounds[si],255	; Clip

		or b mFlags[si],80h	; Kill it

		; Have we killed ourselves ?

		cmp si,bx		; Same ?
		jz HTF_1		; Yes, don't transfer souls

		; Now transfer its' souls count

		mov cx,mSouls[si]	; Giz its souls
		add mSouls[bx],cx	; Add them to the weapons' owner				

		; Iff it had a sword, we must undraw it

HTF_1:		test b mFlags[si],02h	; Check sword
		jz HT_NoSword		; No, skip

		; Remove the damn' thing

		mov di,mSwordSeg[si]	; Giz seg				

		cmp di,0		; Valid ?
		jz HT_NoSword_R		; No, skip

		mov es,di		; Set it

		mov di,mSwordOff[si]	; Off

		; Iff this is a sword, remove it

		mov al,es:[di]		; Giz the char
		and al,0FCh		; E4 .. E7

		cmp al,cSwords		; Is it a sword ?
		jne HT_NoSword_R	; No, skip

		; It's a sword, clear it

		mov al,0		; Clear it
		mov es:[di],al		;
		call ShowAddr		;

HT_NoSword_R:	mov di,mSeg[si]		; Point at maze
		mov es,di		;
		mov di,mOff[si]		;

		; Was it a man ?

HT_NoSword:	test b mFlags[si],04h	; Man or thing ?
		jnz HTK_Man		; Man

		; Now change char dep. on ah

		cmp ah,0		; Sword ?
		jne HTK_NS		; No

		; Killed with sword

		mov al,cDead_Sword	; Get char

HT_Show:	mov es:[di],al		; Place in maze
		call ShowAddr		;

HT_X:		pop cx			; Restore
		pop si			;
		pop ds			;

		ret			; Done

		; Dead man

HTK_Man:	mov al,cDead_Man	; Cross Char

		mov es:[di],al		; Draw
		call ShowAddr		;

		mov ax,es		; Move down
		add ax,BM_Y_Stride	;
		mov es,ax		;

		mov al,cDead_Man+1	; Cross base

		mov es:[di],al		; Draw
		call ShowAddr		; 

		jmp s HT_X		; Done

		; Not killed with sword

HTK_NS:		cmp ah,2		; Killed by magic
		jne HTK_A		; No, arrow

		or b mFlags[si],40h	; Assert steaming flag

		mov b mSteamCnt[si],0	; Reset steam cntr

		; Change characters

		mov b mChar[si],cDead_Magic ; Steam char

		jmp s HT_X		; Done

		; Killed with an arrow

HTK_A:		mov al,cDead_Arrow	; Char

		jmp s HT_Show		; Store it

; Given es:di = ptr to a thing (or man) return ds:si as a ptr to it, else NZ

; ie, this routine finds the data area of a thing, given its maze position

Find_Thing:	mov si,cs:Monster_Base	; Point at first one
		mov ds,si		;
		xor si,si		;

		; Get segment into a useful register

		mov bx,es		; Giz segment

		; Is it a man ?

		mov al,es:[di]		; Giz char

		and al,0F8h		; Clip to type

		cmp al,cMan		; Man ?
		jne FT_OK		; No, skip

		; It is a man, is it his head ?

		test b es:[di],1	; Odd or even char ?
		jz FT_OK		; Yes, it is his head, address is valid

		; Yes, this is his legs, we must point at his head to find him

		sub bx,BM_Y_Stride	; Move up one line

FT_OK:		mov cx,nMons+1		; Number
		mov dx,lMon		; Length

FT_Lp:		cmp di,mOff[si]		; Same X ?
		je FT_1			; Yes

FT_Next:	add si,dx		; Skip

		loop FT_Lp		; Loop

		xor ax,ax		; Not found (NZ)
		inc ax			;
		ret			;

FT_1:		cmp bx,mSeg[si]		; Same Y ?
		jne FT_Next		; No, skip

		test b mFlags[si],080h	; Dead ?
		jnz FT_Next		; Yes

		ret			; Found (Z)

; Give us a new projectile in cs:di, screws ax

New_Proj:	mov di,cs:pFreeProj	; Point at the first free

		cmp di,0		; Any ?
		jz NP_Fail		; No, skip

		mov ax,cs:ppNext[di]	; Get ptr to next
		mov cs:pFreeProj,ax	; Store ptr to next

		clc			; OK
		ret			;

NP_Fail:	stc			; Fail
		ret			;

; Return a projectile (cs:si) to free-space

Kill_Proj:	mov ax,cs:pFreeProj	; Add to list
		mov cs:ppNext[si],ax	; Add to front

		mov cs:pFreeProj,si	; Save ptr

		ret			; Done

; Fixed data here

Light_Tab	db 1,3			; Speeds for lightning
		db 1,4			;
		db 1,5			;
		db 1,6			;
		db 30,7			;
		db 10,8			;
		db 10,9			;
		db 10,11		;
		db 10,12		;
		db 10,14		;
		db 10,18		;

		db 0,0			; End

Fire_Tab	db 2,8			; Speeds for fire
		db 4,9			;
		db 5,10			;
		db 4,11			;
		db 3,12			;
		db 2,13			;
		db 2,14			;
		db 3,15			;
		db 4,17			;
		db 5,19			;
		db 6,21			;
		db 5,22			;
		db 4,23			;

		db 0,0			; End

; Variables here

pProjList	dw ?			; List of projectiles
pFreeProj	dw ?			; Free space list

